var Tinkerforge = require('../Tinkerforge')
,   Conf        = require('./config.json')
,   Helper      = require('../Adawim/helper')
,   Log         = require('../Adawim/logging')
,   http        = require('http');


Helper.each(Conf.items, function(item) {
  connect(item);
});


/* private */
function reconnect(item) {
  Log.debug('Reconnect ' + item.host);
  setTimeout(connect(item), 10000);
}

/* private */
function connect(item) {
  var HOST = item.host;
  var PORT = item.port;
  var UID = item.uid;

  Log.log('Init ' + UID + ' @' + HOST);
  
  var ipcon = new Tinkerforge.IPConnection(); // Create IP connection
  var md = new Tinkerforge.BrickletMotionDetector(UID, ipcon); // Create device object
  
  var counter = 0;
  var readyForNextNotification = true;
  
  ipcon.connect(HOST, PORT,
    function (error) {
    
      /*
        IPConnection.ERROR_ALREADY_CONNECTED = 11
        IPConnection.ERROR_NOT_CONNECTED = 12
        IPConnection.ERROR_CONNECT_FAILED = 13
        IPConnection.ERROR_INVALID_FUNCTION_ID = 21
        IPConnection.ERROR_TIMEOUT = 31
        IPConnection.ERROR_INVALID_PARAMETER = 41
        IPConnection.ERROR_FUNCTION_NOT_SUPPORTED = 42
        IPConnection.ERROR_UNKNOWN_ERROR = 43
      */

      Log.error('Error @'+HOST+': ' + error);
      
      if(error === 13) {
        reconnect(item);
      }
    }
  ); // Connect to brickd
  // Don't use device before ipcon is connected
  
  ipcon.on(Tinkerforge.IPConnection.CALLBACK_CONNECTED,
    function (connectReason) {
      
    }
  );
    
  // Register motion detected callback
  md.on(Tinkerforge.BrickletMotionDetector.CALLBACK_MOTION_DETECTED,
    // Callback function for motion detected callback
    function () {
      Log.log('Motion detected');
      var callOptions = item.on.motion.call;
      doMotionCall(HOST, callOptions);
    }
  );
  
  process.on( 'SIGINT', function() {
    Log.log( "Gracefully disconnect " + HOST );
    ipcon.disconnect();
    process.exit( );
  });
}

/* private */
function doMotionCall(host, options) {
  const HOST = host;
  
  
  callback = function(response) {
    var str = '';
  
    //another chunk of data has been recieved, so append it to `str`
    response.on('data', function (chunk) {
      str += chunk;
    });

    //the whole response has been recieved, so we just print it out here
    response.on('end', function () {
      Log.log(HOST + ': ' + str);
    });
  }
  
  var req = http.request(options, function(res) {
    //Log.inspect('Result', res);
  });
  
  req.on('error', function(err) {
    if(HOST) {
      Log.error(HOST + ': ' + err);
    } else {
      Log.error(err);
    }
  });
  
  req.end();
}